2019-10-18 23:22 EDT


View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0001220FSSCPmodular tablespublic2007-03-22 21:41
ReporterARSPR 
Assigned Totaylor 
PrioritynormalSeveritymajorReproducibilityalways
StatusresolvedResolutionfixed 
PlatformP4 2.8 HT - 1.5GB - 7800GSOSWindows XPOS VersionSP2
Product Version3.6.9 
Target VersionFixed in Version3.6.10 
Summary0001220: -wep.tbm table is not loading (fs bug or table bug ????)
DescriptionI have a serious problem while testing DaBrain's next media vps.

I'm testing his effects compilation. As they are supposed to fully replace retail effects, I've disabled sparky_fs2 ones. I've done this, uncompressing sparky_fs2 in a folder so I load its contents through -MOD flag. In this way I'm not loading sparky_fs2 effects contents at all cos I've renamed effects folder to 'effects kk'.

Then I load DaBrain's NewMediaEffects which has a mv_effects-wep.tbm table which, as example, sets (I upload the table, nevertheless):

$Name: Subach HL-7
+nocreate
@Laser Bitmap: Subach_AniBitmap
@Laser Glow: Subach_Glow


I also attach fs2_open.log where you can see how I actually load this table:
TBM => Starting parse of 'mv_effects-wep.tbm' ...


Subach_AniBitmap is not missing (it is actually an EFF) but I get the next error when FS2_open loads:

===================================================================
Warning: Couldn't open texture 'newglo9'
referenced by weapon 'Subach HL-7'

File:J:\src\cvs\fs2_open_3_6_9.final\code\Weapon\Weapons.cpp
Line: 2145
[This filename points to the location of a file on the computer that built this executable]

Call stack:
------------------------------------------------------------------
    parse_weaponstbl() weapon_init() game_init() game_main() WinMain() WinMainCRTStartup() kernel32.dll 7c816fd7()
------------------------------------------------------------------
======================================================


Retail root_fs2.vp weapons.tbl actually sets:

$Name: @Subach HL-7
@Laser Bitmap: newglo9
@Laser Glow: 2_laserglow03

As I've disabled sparky_fs2 effects folder, newglo9 isn't available. BUT Subach HL-7 isn't supposed to use it anymore ...

So why aren't mv_effects-wep.tbm settings applied? Is it a table bug or a code bug?

(I get similar errors with ALL weapons. I've checked the tbm table with wiki and it seems to be OK. I need expert help here).
Additional InformationPlease, check it ASAP cos I need this "bug" (table or Fs2_open) solved to continue testing DaBrain's new MediaVps.
TagsNo tags attached.
Attached Files

-Relationships
+Relationships

-Notes

~0007463

taylor (administrator)

And why does the first entry in mv_effecs-wep.tbm not contain anything? That would likely mess something up.

~0007464

ARSPR (reporter)

I don't know. Ask DaBrain ...

Nevertheless I've tried deleting the first entry and it's the same.

I upload it too. I've renamed it to mv_effects2-wep.tbm, so we can track different versions.

~0007465

Da_Brain (developer)

Got your PM.

Is it possible that I just missed a few files?

The new VPs only replace all models and textures. I'm not sure about the effects.

Try using the effects from the sparky.vp additionally.

~0007466

taylor (administrator)

Also make sure that mv_models-wep.tbm and mv_tech-wep.tbm don't have anything that might reset the bitmap. Since they are loaded after mv_effects-wep.tbm, it's possible that one of them is just resetting the values.

~0007467

taylor (administrator)

I just read what WMCoolmon wrote on the forum thread, and I think that he nailed it. I have been wanting to do delayed loading for a while anyway, so I guess I can go ahead and do that now. That way it won't try and load any bitmaps until it's loading a mission (there are issues there, so I'm not 100% sure I can do that), or at least have it not do any bitmap stuff until all of the tbl/tbm files have been parsed.

~0007471

WMCoolmon (developer)

The only reason I didn't suggest delayed loading is that it takes away the advantage of being able to fallback to one of the previously-defined media fields, so that even if media is missing, release builds will continue to function. Since modular tables should be used to add to, rather than remove, an existing codebase, this error shouldn't be common.

I don't know the consequences of that on the bmpman side of things though, so go ahead and do as you see fit.

~0007472

taylor (administrator)

I'll just add the capability to my "X" series of builds which start coming out in another week or two. I also have -jpgtga removed (like HEAD already has), and simultaneous searching of all image types through bmpman. Delayed loading has it's pitfalls, and simultaneous searching is slower, so we'll see how it tests in the real world and I'll only commit to CVS whatever is proven to work well in those builds. :)

~0007479

ARSPR (reporter)

Thanks for your help.

Just to check I've understood it:

+ On starting, FS2 loads ALL weapons and ALL their textures from ALL tables, even the useless ones because other table entries. This is what causes the error as I've 'deleted' unused but pointed textures.


+ Taylor is now recoding all this stuff to make FS2:
- Loading weapons on mission beginning and only the real used ones. (ie. loading only Maxim and Subach HL-7 but not Circe, Kayser ...).
- Loading just final textures, not every single one. (ie. no more newglo9 loading anymore)
- -jpgtga is always going to be on.
- Related to 0001123. When loading one texture, FS2 is going to search for ALL texture formats in EACH folder/vp instead of present behaviour (setting one format and looking for it in ALL folders/vps then moving to next format and searching again).

~0007480

taylor (administrator)

Yep, that's the plan. :)

I've got everything but a couple of the beam related graphics setup as delayed already. Then I'll move on to ships.tbl stuff.

~0007515

taylor (administrator)

All done, and it's working great so far. I think that I'm going to move on the other tables which have modular versions as well. Mission load times are going to get a bit longer, but game start times should decrease substantially.

I will put out at least one public test build with the changes before I commit it all to CVS though, just to make sure I didn't break anything.

~0007878

taylor (administrator)

Fixered.
+Notes

-Issue History
Date Modified Username Field Change
2007-01-15 15:34 ARSPR New Issue
2007-01-15 15:34 ARSPR Status new => assigned
2007-01-15 15:34 ARSPR Assigned To => WMCoolmon
2007-01-15 15:34 ARSPR File Added: mv_effects-wep.tbm
2007-01-15 15:35 ARSPR File Added: fs2_open.log
2007-01-15 16:00 taylor Note Added: 0007463
2007-01-15 16:25 ARSPR Note Added: 0007464
2007-01-15 16:26 ARSPR File Added: mv_effects2-wep.tbm
2007-01-15 18:10 Da_Brain Note Added: 0007465
2007-01-15 19:06 taylor Note Added: 0007466
2007-01-15 19:23 taylor Note Added: 0007467
2007-01-16 05:00 WMCoolmon Note Added: 0007471
2007-01-16 09:28 taylor Note Added: 0007472
2007-01-17 10:33 ARSPR Note Added: 0007479
2007-01-17 10:53 taylor Note Added: 0007480
2007-01-17 20:40 taylor Assigned To WMCoolmon => taylor
2007-01-22 12:15 taylor Note Added: 0007515
2007-03-22 21:41 taylor Status assigned => resolved
2007-03-22 21:41 taylor Fixed in Version => 3.6.10
2007-03-22 21:41 taylor Resolution open => fixed
2007-03-22 21:41 taylor Note Added: 0007878
+Issue History